'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

const index = require('./index-b286d777.js');

var SmileyState;
(function (SmileyState) {
  SmileyState["SUPER"] = "super";
  SmileyState["WELL"] = "well";
  SmileyState["OKAY"] = "okay";
  SmileyState["NOT_WELL"] = "not_well";
  SmileyState["BAD"] = "bad";
})(SmileyState || (SmileyState = {}));

const badSvg = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<svg version=\"1.1\" id=\"Layer_1\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" x=\"0px\" y=\"0px\"\n\t viewBox=\"0 0 165 165\" style=\"enable-background:new 0 0 165 165;\" xml:space=\"preserve\">\n<style type=\"text/css\">\n\t.st0{fill:url(#Ellipse_1843_1_);}\n\t.st1{fill:#FFFFFF;}\n\t.st2{fill:none;stroke:#0363FA;stroke-width:6;}\n\t.st3{fill:#0363FA;}\n</style>\n<g id=\"Group_5620\" transform=\"translate(15698 14884)\">\n\n\t\t<radialGradient id=\"Ellipse_1843_1_\" cx=\"-15911.1973\" cy=\"-14382.6582\" r=\"0.5\" gradientTransform=\"matrix(165 0 0 -165 2609732 -2387940.25)\" gradientUnits=\"userSpaceOnUse\">\n\t\t<stop  offset=\"0\" style=\"stop-color:#0363FA\"/>\n\t\t<stop  offset=\"1\" style=\"stop-color:#0363FA;stop-opacity:0\"/>\n\t</radialGradient>\n\t<circle id=\"Ellipse_1843\" class=\"st0\" cx=\"-15615.5\" cy=\"-14801.5\" r=\"82.5\"/>\n\t<g id=\"Group_5615\">\n\t\t<g id=\"Group_5473\" transform=\"translate(-15680 -14866)\">\n\t\t\t<g id=\"Ellipse_1774\" transform=\"translate(0 0)\">\n\t\t\t\t<circle class=\"st1\" cx=\"64.3\" cy=\"64.3\" r=\"64.3\"/>\n\t\t\t\t<circle class=\"st2\" cx=\"64.3\" cy=\"64.3\" r=\"61.3\"/>\n\t\t\t</g>\n\t\t\t<g id=\"Group_5469\" transform=\"translate(32.83 43.185)\">\n\t\t\t\t<circle id=\"Ellipse_1772\" class=\"st3\" cx=\"7.7\" cy=\"7.7\" r=\"7.7\"/>\n\t\t\t\t<circle id=\"Ellipse_1773\" class=\"st3\" cx=\"56.3\" cy=\"7.7\" r=\"7.7\"/>\n\t\t\t</g>\n\t\t</g>\n\t\t<path class=\"st3\" d=\"M-15641.9-14764.6c-0.2,0-0.4,0-0.6-0.1c-1.6-0.3-2.7-1.9-2.3-3.6c2.5-11.7,11.7-20.9,23.4-23.4\n\t\t\tc16.4-3.5,32.6,7,36.1,23.4c0.3,1.6-0.7,3.2-2.3,3.6c-1.6,0.3-3.2-0.7-3.6-2.3c-1.4-6.4-5.1-11.8-10.6-15.4\n\t\t\tc-5.5-3.5-12-4.8-18.4-3.4c-9.4,2-16.8,9.4-18.8,18.8C-15639.3-14765.6-15640.5-14764.6-15641.9-14764.6z\"/>\n\t</g>\n</g>\n</svg>\n";

const notWellSvg = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<svg version=\"1.1\" id=\"Layer_1\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" x=\"0px\" y=\"0px\"\n\t viewBox=\"0 0 165 165\" style=\"enable-background:new 0 0 165 165;\" xml:space=\"preserve\">\n<style type=\"text/css\">\n\t.st0{fill:url(#Ellipse_1780_1_);}\n\t.st1{fill:#FFFFFF;}\n\t.st2{fill:none;stroke:#007EF0;stroke-width:6;}\n\t.st3{fill:#007EF0;}\n</style>\n<radialGradient id=\"Ellipse_1780_1_\" cx=\"-16338.5908\" cy=\"-14563.7559\" r=\"0.4992\" gradientTransform=\"matrix(165 0 0 -165 2695950 -2402937.25)\" gradientUnits=\"userSpaceOnUse\">\n\t<stop  offset=\"0\" style=\"stop-color:#007EF0\"/>\n\t<stop  offset=\"1\" style=\"stop-color:#007EF0;stop-opacity:0\"/>\n</radialGradient>\n<circle id=\"Ellipse_1780\" class=\"st0\" cx=\"82.5\" cy=\"82.5\" r=\"82.5\"/>\n<g id=\"Ellipse_1775\" transform=\"translate(2632 -21324)\">\n\t<circle class=\"st1\" cx=\"-2549.5\" cy=\"21406.5\" r=\"64.5\"/>\n\t<circle class=\"st2\" cx=\"-2549.5\" cy=\"21406.5\" r=\"61.5\"/>\n</g>\n<g id=\"Group_4832\" transform=\"translate(2664.544 -21280.688)\">\n\t<circle id=\"Ellipse_1772\" class=\"st3\" cx=\"-2606.3\" cy=\"21349.7\" r=\"7.7\"/>\n\t<circle id=\"Ellipse_1773\" class=\"st3\" cx=\"-2557.7\" cy=\"21349.7\" r=\"7.7\"/>\n</g>\n<path class=\"st3\" d=\"M107.7,111.3c2.3,0,3.6-2.7,2.1-4.4c-6.5-7.9-16.3-13-27.3-13s-20.9,5.1-27.3,13c-1.4,1.8-0.2,4.4,2.1,4.4\n\tH107.7z\"/>\n</svg>\n";

const okaySvg = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<svg version=\"1.1\" id=\"Layer_1\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" x=\"0px\" y=\"0px\"\n\t viewBox=\"0 0 165 165\" style=\"enable-background:new 0 0 165 165;\" xml:space=\"preserve\">\n<style type=\"text/css\">\n\t.st0{fill:url(#Ellipse_1780_1_);}\n\t.st1{fill:#FFFFFF;}\n\t.st2{fill:none;stroke:#009BE6;stroke-width:6;}\n\t.st3{fill:#009BE6;}\n</style>\n<g id=\"Group_5618\" transform=\"translate(15698 15238)\">\n\n\t\t<radialGradient id=\"Ellipse_1780_1_\" cx=\"-15911.1973\" cy=\"-14736.6582\" r=\"0.5\" gradientTransform=\"matrix(165 0 0 -165 2609732 -2446704.25)\" gradientUnits=\"userSpaceOnUse\">\n\t\t<stop  offset=\"0\" style=\"stop-color:#009BE6\"/>\n\t\t<stop  offset=\"1\" style=\"stop-color:#009BE6;stop-opacity:0\"/>\n\t</radialGradient>\n\t<circle id=\"Ellipse_1780\" class=\"st0\" cx=\"-15615.5\" cy=\"-15155.5\" r=\"82.5\"/>\n\t<g id=\"Group_5471\" transform=\"translate(-18165 6104)\">\n\t\t<g id=\"Ellipse_1776\" transform=\"translate(2485 -21324)\">\n\t\t\t<circle class=\"st1\" cx=\"64.5\" cy=\"64.5\" r=\"64.5\"/>\n\t\t\t<circle class=\"st2\" cx=\"64.5\" cy=\"64.5\" r=\"61.5\"/>\n\t\t</g>\n\t\t<g id=\"Group_4831\" transform=\"translate(2517.544 -21280.688)\">\n\t\t\t<circle id=\"Ellipse_1772\" class=\"st3\" cx=\"7.7\" cy=\"7.7\" r=\"7.7\"/>\n\t\t\t<circle id=\"Ellipse_1773\" class=\"st3\" cx=\"56.3\" cy=\"7.7\" r=\"7.7\"/>\n\t\t</g>\n\t\t<path class=\"st3\" d=\"M2561.2-21231.9h-22.5c-2.8,0-5-2.2-5-5s2.2-5,5-5h22.5c2.8,0,5,2.2,5,5S2564-21231.9,2561.2-21231.9z\"/>\n\t</g>\n</g>\n</svg>\n";

const superSvg = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<svg version=\"1.1\" id=\"Layer_1\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" x=\"0px\" y=\"0px\"\n\t viewBox=\"0 0 165 165\" style=\"enable-background:new 0 0 165 165;\" xml:space=\"preserve\">\n<style type=\"text/css\">\n\t.st0{opacity:0.7;fill:url(#Ellipse_1780_1_);enable-background:new    ;}\n\t.st1{fill:#FFFFFF;}\n\t.st2{fill:none;stroke:#2BD4CF;stroke-width:6;}\n\t.st3{fill:#2BD4CF;}\n</style>\n<g id=\"Group_5616\" transform=\"translate(15698 15593)\">\n\n\t\t<radialGradient id=\"Ellipse_1780_1_\" cx=\"-15911.1973\" cy=\"-15091.6582\" r=\"0.5\" gradientTransform=\"matrix(165 0 0 -165 2609732 -2505634.25)\" gradientUnits=\"userSpaceOnUse\">\n\t\t<stop  offset=\"0\" style=\"stop-color:#2BD4CF\"/>\n\t\t<stop  offset=\"1\" style=\"stop-color:#2BD4CF;stop-opacity:0\"/>\n\t</radialGradient>\n\t<circle id=\"Ellipse_1780\" class=\"st0\" cx=\"-15615.5\" cy=\"-15510.5\" r=\"82.5\"/>\n\t<g id=\"Group_5476\" transform=\"translate(-17839 5749)\">\n\t\t<g id=\"Ellipse_1778\" transform=\"translate(2159 -21324)\">\n\t\t\t<circle class=\"st1\" cx=\"64.5\" cy=\"64.5\" r=\"64.5\"/>\n\t\t\t<circle class=\"st2\" cx=\"64.5\" cy=\"64.5\" r=\"61.5\"/>\n\t\t</g>\n\t\t<g id=\"Group_4835\" transform=\"translate(2191.25 -21280.74)\">\n\t\t\t<circle id=\"Ellipse_1772\" class=\"st3\" cx=\"7.7\" cy=\"7.7\" r=\"7.7\"/>\n\t\t\t<circle id=\"Ellipse_1773\" class=\"st3\" cx=\"56.8\" cy=\"7.7\" r=\"7.7\"/>\n\t\t</g>\n\t\t<path class=\"st3\" d=\"M2252.9-21246.9c-0.8-0.9-1.9-1.5-3.1-1.5c-17.5,0-50.6,0-51.7,0c-1.1,0-2.1,0.4-2.9,1.2\n\t\t\tc-1,1-1.4,2.3-1.1,3.7c2.5,11.7,11.7,20.9,23.4,23.4c2.1,0.5,4.3,0.7,6.4,0.7c5.8,0,11.5-1.7,16.5-4.9\n\t\t\tc6.8-4.4,11.5-11.2,13.2-19.2C2253.9-21244.8,2253.6-21246,2252.9-21246.9z\"/>\n\t</g>\n</g>\n</svg>\n";

const wellSvg = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<svg version=\"1.1\" id=\"Layer_1\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" x=\"0px\" y=\"0px\"\n\t viewBox=\"0 0 165 165\" style=\"enable-background:new 0 0 165 165;\" xml:space=\"preserve\">\n<style type=\"text/css\">\n\t.st0{fill:url(#Ellipse_1780_1_);}\n\t.st1{fill:#FFFFFF;}\n\t.st2{fill:#0AB9DB;}\n</style>\n<g id=\"Group_5617\" transform=\"translate(15698 15416)\">\n\n\t\t<radialGradient id=\"Ellipse_1780_1_\" cx=\"-15911.1973\" cy=\"-14914.6582\" r=\"0.5\" gradientTransform=\"matrix(165 0 0 -165 2609732 -2476252.25)\" gradientUnits=\"userSpaceOnUse\">\n\t\t<stop  offset=\"0\" style=\"stop-color:#0AB9DB\"/>\n\t\t<stop  offset=\"1\" style=\"stop-color:#0AB9DB;stop-opacity:0\"/>\n\t</radialGradient>\n\t<circle id=\"Ellipse_1780\" class=\"st0\" cx=\"-15615.5\" cy=\"-15333.5\" r=\"82.5\"/>\n\t<g id=\"Group_5470\" transform=\"translate(-18003.727 5926.273)\">\n\t\t<g id=\"Path_4638\" transform=\"translate(2323.728 -21324.273)\">\n\t\t\t<path class=\"st1\" d=\"M64.5,126c-8.3,0-16.4-1.6-23.9-4.8c-3.6-1.5-7.2-3.4-10.4-5.7c-3.3-2.2-6.3-4.7-9.1-7.5\n\t\t\t\tc-2.8-2.8-5.3-5.8-7.5-9.1c-2.2-3.3-4.1-6.8-5.7-10.4C4.6,80.9,3,72.8,3,64.5s1.6-16.4,4.8-23.9c1.5-3.6,3.4-7.2,5.7-10.4\n\t\t\t\tc2.2-3.3,4.7-6.3,7.5-9.1c2.8-2.8,5.8-5.3,9.1-7.5c3.3-2.2,6.8-4.1,10.4-5.7C48.1,4.6,56.2,3,64.5,3s16.4,1.6,23.9,4.8\n\t\t\t\tc3.6,1.5,7.2,3.4,10.4,5.7c3.3,2.2,6.3,4.7,9.1,7.5c2.8,2.8,5.3,5.8,7.5,9.1c2.2,3.3,4.1,6.8,5.7,10.4c3.2,7.6,4.8,15.6,4.8,23.9\n\t\t\t\ts-1.6,16.4-4.8,23.9c-1.5,3.6-3.4,7.2-5.7,10.4c-2.2,3.3-4.7,6.3-7.5,9.1c-2.8,2.8-5.8,5.3-9.1,7.5c-3.3,2.2-6.8,4.1-10.4,5.7\n\t\t\t\tC80.9,124.4,72.8,126,64.5,126z\"/>\n\t\t\t<path class=\"st2\" d=\"M64.5,6C32.2,6,6,32.2,6,64.5S32.2,123,64.5,123S123,96.8,123,64.5S96.8,6,64.5,6 M64.5,0\n\t\t\t\tC100.1,0,129,28.9,129,64.5S100.1,129,64.5,129S0,100.1,0,64.5S28.9,0,64.5,0z\"/>\n\t\t</g>\n\t\t<g id=\"Group_4834\" transform=\"translate(2356.136 -21280.984)\">\n\t\t\t<circle id=\"Ellipse_1772\" class=\"st2\" cx=\"7.7\" cy=\"7.7\" r=\"7.7\"/>\n\t\t\t<circle id=\"Ellipse_1773\" class=\"st2\" cx=\"56.5\" cy=\"7.7\" r=\"7.7\"/>\n\t\t</g>\n\t\t<path class=\"st2\" d=\"M2414.7-21246c-0.6-1.5-2.1-2.4-3.7-2.4c0,0,0,0,0,0c-17,0-42.7,0-44.5,0c-0.8,0-1.6,0.2-2.3,0.6\n\t\t\tc-1.6,1-2.3,3-1.6,4.8c0.3,0.8,0.8,1.4,1.3,1.8c0.2,0.2,0.4,0.4,0.7,0.7c6.8,6.5,15.4,9.7,24.1,9.7c9.2,0,18.4-3.6,25.2-10.8\n\t\t\tC2415-21242.8,2415.3-21244.6,2414.7-21246z\"/>\n\t</g>\n</g>\n</svg>\n";

const emptySvg = "<?xml version=\"1.0\" encoding=\"UTF-8\" standalone=\"no\"?><!DOCTYPE svg PUBLIC \"-//W3C//DTD SVG 1.1//EN\" \"http://www.w3.org/Graphics/SVG/1.1/DTD/svg11.dtd\"><svg width=\"100%\" height=\"100%\" viewBox=\"0 0 165 165\" version=\"1.1\" xmlns=\"http://www.w3.org/2000/svg\" xmlns:xlink=\"http://www.w3.org/1999/xlink\" xml:space=\"preserve\" xmlns:serif=\"http://www.serif.com/\" style=\"fill-rule:evenodd;clip-rule:evenodd;\"><g id=\"Group_5616\"><circle id=\"Ellipse_1780\" cx=\"82.5\" cy=\"82.5\" r=\"82.5\" style=\"fill:url(#_Radial1);\"/><g id=\"Group_5476\"><g id=\"Ellipse_1778\"><circle cx=\"82.5\" cy=\"82.5\" r=\"64.5\" style=\"fill:#fff;\"/><circle cx=\"82.5\" cy=\"82.5\" r=\"61.5\" style=\"fill:none;stroke:#2bd4cf;stroke-width:6px;\"/></g></g></g><defs><radialGradient id=\"_Radial1\" cx=\"0\" cy=\"0\" r=\"1\" gradientUnits=\"userSpaceOnUse\" gradientTransform=\"matrix(82.5,0,0,82.5,82.5,82.5)\"><stop offset=\"0\" style=\"stop-color:#2bd4cf;stop-opacity:0.7\"/><stop offset=\"1\" style=\"stop-color:#2bd4cf;stop-opacity:0\"/></radialGradient></defs></svg>";

const SmileyAsset = ({ smiley }) => {
  if (!smiley) {
    return index.h("div", { innerHTML: emptySvg });
  }
  switch (smiley) {
    case SmileyState.BAD:
      return index.h("div", { innerHTML: badSvg });
    case SmileyState.NOT_WELL:
      return index.h("div", { innerHTML: notWellSvg });
    case SmileyState.OKAY:
      return index.h("div", { innerHTML: okaySvg });
    case SmileyState.SUPER:
      return index.h("div", { innerHTML: superSvg });
    default:
      return index.h("div", { innerHTML: wellSvg });
  }
};

const DEFAULT_LANGUAGE = 'en';
const SUPPORTED_LANGUAGES = ['de', 'en'];
const TRANSLATIONS = {
  de: {
    question: 'Wie fühlen Sie sich heute?',
    super: 'sehr gut',
    well: 'gut',
    okay: 'soso lala',
    not_well: 'nicht so gut',
    bad: 'nicht gut'
  },
  en: {
    question: 'How do you feel today?',
    super: 'super',
    well: 'well',
    okay: 'okay',
    not_well: 'not so well',
    bad: 'bad'
  }
};
// Source: ngx-translate / https://github.com/ngx-translate/core/blob/a13b700db0e3a509e0e81ef4fe846b7e87f1396b/projects/ngx-translate/core/src/lib/translate.service.ts#L506
const initBrowserLang = () => {
  if (typeof window === 'undefined' || typeof window.navigator === 'undefined') {
    return undefined;
  }
  let browserLang = window.navigator.languages && window.navigator.languages.length > 0 ? window.navigator.languages[0] : null;
  // @ts-ignore
  browserLang = browserLang || window.navigator.language || window.navigator.browserLanguage || window.navigator.userLanguage;
  if (typeof browserLang === 'undefined') {
    return undefined;
  }
  if (browserLang.indexOf('-') !== -1) {
    browserLang = browserLang.split('-')[0];
  }
  if (browserLang.indexOf('_') !== -1) {
    browserLang = browserLang.split('_')[0];
  }
  return browserLang;
};
const browserLang = initBrowserLang();
const translate = (key, customLang) => {
  const lang = customLang || browserLang;
  return TRANSLATIONS[lang !== undefined && SUPPORTED_LANGUAGES.includes(lang) ? lang : DEFAULT_LANGUAGE][key];
};

const debounce = (func, timeout) => {
  let timer;
  return (...args) => {
    const next = () => func(...args);
    if (timer) {
      clearTimeout(timer);
    }
    timer = setTimeout(next, timeout && timeout > 0 ? timeout : 300);
  };
};

const smileyCss = ":host{display:block;width:var(--size, 15rem);height:var(--size, 15rem);position:relative;--zIndex:0}svg{width:100%;aspect-ratio:1/1}@supports not (aspect-ratio: 1/1){svg{width:100%;height:100%}}button{border:none;margin:0;padding:0;background:transparent;color:inherit;font:inherit;cursor:pointer;width:calc(var(--size, 15rem) - var(--margin, 4rem));height:calc(var(--size, 15rem) - var(--margin, 4rem));position:absolute;top:50%;left:50%;transform:translate(-50%, -50%);z-index:var(--zIndex)}button:focus,button:active{outline:var(--outline, none)}label{position:absolute;top:50%;left:50%;transform:translate(-50%, calc(-1 * (var(--size, 15rem) - var(--text-top, 2rem)) / 2));pointer-events:none;font-size:var(--text-font-size, 1.25rem);font-weight:var(--text-font-weight, 400);line-height:var(--text-line-height, 1.6666666667rem);text-align:center}label.question{transform:translate(-50%, -50%);z-index:calc(var(--zIndex) + 1)}label.state{visibility:hidden;opacity:0;transition:opacity 0.15s ease-in}label.state.visible{visibility:visible;opacity:1}";

let Smiley = class {
  constructor(hostRef) {
    index.registerInstance(this, hostRef);
    this.state = index.createEvent(this, "state", 7);
    this.question = true;
    this.stateLabel = 'hidden';
    this.debounceState = debounce(() => this.state.emit(this.smiley));
  }
  componentWillLoad() {
    if (!this.question) {
      this.initState();
    }
  }
  componentDidLoad() {
    if (this.question) {
      this.questionTimeout = setTimeout(() => this.initState(), 2500);
    }
  }
  next() {
    if (this.questionTimeout) {
      clearTimeout(this.questionTimeout);
    }
    if (!this.smiley) {
      this.initState();
      return;
    }
    switch (this.smiley) {
      case SmileyState.BAD:
        this.smiley = SmileyState.SUPER;
        break;
      case SmileyState.NOT_WELL:
        this.smiley = SmileyState.BAD;
        break;
      case SmileyState.OKAY:
        this.smiley = SmileyState.NOT_WELL;
        break;
      case SmileyState.SUPER:
        this.smiley = SmileyState.WELL;
        break;
      default:
        this.smiley = SmileyState.OKAY;
    }
    this.debounceState();
  }
  initState() {
    this.smiley = SmileyState.SUPER;
    this.state.emit(this.smiley);
    setTimeout(() => (this.stateLabel = 'visible'), 50);
  }
  render() {
    return (index.h(index.Host, null, this.renderText(), index.h("button", { onClick: () => this.next(), name: "smiley" }, index.h(SmileyAsset, { smiley: this.smiley }))));
  }
  renderText() {
    if (!this.smiley) {
      return (index.h("label", { key: "question", htmlFor: "smiley", class: "question" }, index.h("slot", { name: "question" }, translate('question'))));
    }
    return (index.h("label", { key: "state", htmlFor: "smiley", class: `state ${this.stateLabel}` }, translate(this.smiley)));
  }
};
Smiley.style = smileyCss;

exports.bonjour_smiley = Smiley;
